/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Indexes;
import de.ship.db.Keys;
import de.ship.db.enums.EnumDevicestate;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.records.TCoreDeviceRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreDevice extends TableImpl<TCoreDeviceRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_device</code>
     */
    public static final TCoreDevice T_CORE_DEVICE = new TCoreDevice();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreDeviceRecord> getRecordType() {
        return TCoreDeviceRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_device.lastchange</code>.
     */
    public final TableField<TCoreDeviceRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_device.pk</code>.
     */
    public final TableField<TCoreDeviceRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_device.device_id</code>. unique device
     * id defined by SHIP-IT
     */
    public final TableField<TCoreDeviceRecord, String> DEVICE_ID = createField(DSL.name("device_id"), SQLDataType.CLOB.nullable(false), this, "unique device id defined by SHIP-IT");

    /**
     * The column <code>common_dd.t_core_device.name</code>. display name of
     * device for end user
     */
    public final TableField<TCoreDeviceRecord, String> NAME = createField(DSL.name("name"), SQLDataType.CLOB.nullable(false), this, "display name of device for end user");

    /**
     * The column <code>common_dd.t_core_device.type</code>. device name
     */
    public final TableField<TCoreDeviceRecord, String> TYPE = createField(DSL.name("type"), SQLDataType.CLOB, this, "device name");

    /**
     * The column <code>common_dd.t_core_device.manufactor</code>. manufactor
     * name
     */
    public final TableField<TCoreDeviceRecord, String> MANUFACTOR = createField(DSL.name("manufactor"), SQLDataType.CLOB, this, "manufactor name");

    /**
     * The column <code>common_dd.t_core_device.serialnr</code>. serial number
     */
    public final TableField<TCoreDeviceRecord, String> SERIALNR = createField(DSL.name("serialnr"), SQLDataType.CLOB, this, "serial number");

    /**
     * The column <code>common_dd.t_core_device.invnr</code>. ship internal
     * inventory number
     */
    public final TableField<TCoreDeviceRecord, String> INVNR = createField(DSL.name("invnr"), SQLDataType.CLOB, this, "ship internal inventory number");

    /**
     * The column <code>common_dd.t_core_device.buildyear</code>. construction
     * year
     */
    public final TableField<TCoreDeviceRecord, String> BUILDYEAR = createField(DSL.name("buildyear"), SQLDataType.CLOB, this, "construction year");

    /**
     * The column <code>common_dd.t_core_device.state</code>. state of device
     */
    public final TableField<TCoreDeviceRecord, EnumDevicestate> STATE = createField(DSL.name("state"), SQLDataType.VARCHAR.asEnumDataType(EnumDevicestate.class), this, "state of device");

    /**
     * The column <code>common_dd.t_core_device.contact</code>. contact, if not
     * medical technic
     */
    public final TableField<TCoreDeviceRecord, String> CONTACT = createField(DSL.name("contact"), SQLDataType.CLOB, this, "contact, if not medical technic");

    /**
     * The column <code>common_dd.t_core_device.location</code>. location of
     * device
     */
    public final TableField<TCoreDeviceRecord, String> LOCATION = createField(DSL.name("location"), SQLDataType.CLOB, this, "location of device");

    /**
     * The column <code>common_dd.t_core_device.obs_name</code>. observation
     * name
     */
    public final TableField<TCoreDeviceRecord, String> OBS_NAME = createField(DSL.name("obs_name"), SQLDataType.CLOB, this, "observation name");

    /**
     * The column <code>common_dd.t_core_device.fk_element</code>. study the
     * device was bought for
     */
    public final TableField<TCoreDeviceRecord, Integer> FK_ELEMENT = createField(DSL.name("fk_element"), SQLDataType.INTEGER, this, "study the device was bought for");

    /**
     * The column <code>common_dd.t_core_device.resp_obs_mail</code>. mail of
     * responsible observation person
     */
    public final TableField<TCoreDeviceRecord, String> RESP_OBS_MAIL = createField(DSL.name("resp_obs_mail"), SQLDataType.CLOB, this, "mail of responsible observation person");

    /**
     * The column <code>common_dd.t_core_device.resp_qa</code>. mail of
     * responsible quality person
     */
    public final TableField<TCoreDeviceRecord, String> RESP_QA = createField(DSL.name("resp_qa"), SQLDataType.CLOB, this, "mail of responsible quality person");

    /**
     * The column <code>common_dd.t_core_device.color</code>. color of device
     * for analysis views
     */
    public final TableField<TCoreDeviceRecord, String> COLOR = createField(DSL.name("color"), SQLDataType.CLOB, this, "color of device for analysis views");

    /**
     * The column <code>common_dd.t_core_device.note</code>. notes for that
     * device
     */
    public final TableField<TCoreDeviceRecord, String> NOTE = createField(DSL.name("note"), SQLDataType.CLOB, this, "notes for that device");

    private TCoreDevice(Name alias, Table<TCoreDeviceRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreDevice(Name alias, Table<TCoreDeviceRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_device</code> table reference
     */
    public TCoreDevice(String alias) {
        this(DSL.name(alias), T_CORE_DEVICE);
    }

    /**
     * Create an aliased <code>common_dd.t_core_device</code> table reference
     */
    public TCoreDevice(Name alias) {
        this(alias, T_CORE_DEVICE);
    }

    /**
     * Create a <code>common_dd.t_core_device</code> table reference
     */
    public TCoreDevice() {
        this(DSL.name("t_core_device"), null);
    }

    public <O extends Record> TCoreDevice(Table<O> path, ForeignKey<O, TCoreDeviceRecord> childPath, InverseForeignKey<O, TCoreDeviceRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_DEVICE);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreDevicePath extends TCoreDevice implements Path<TCoreDeviceRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreDevicePath(Table<O> path, ForeignKey<O, TCoreDeviceRecord> childPath, InverseForeignKey<O, TCoreDeviceRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreDevicePath(Name alias, Table<TCoreDeviceRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreDevicePath as(String alias) {
            return new TCoreDevicePath(DSL.name(alias), this);
        }

        @Override
        public TCoreDevicePath as(Name alias) {
            return new TCoreDevicePath(alias, this);
        }

        @Override
        public TCoreDevicePath as(Table<?> alias) {
            return new TCoreDevicePath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public List<Index> getIndexes() {
        return Arrays.asList(Indexes.IDX_CORE_DEVICE_FK_ELEMENT);
    }

    @Override
    public Identity<TCoreDeviceRecord, Integer> getIdentity() {
        return (Identity<TCoreDeviceRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreDeviceRecord> getPrimaryKey() {
        return Keys.PK_CORE_DEVICE;
    }

    @Override
    public List<UniqueKey<TCoreDeviceRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_CORE_DEVICE);
    }

    @Override
    public List<ForeignKey<TCoreDeviceRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_DEVICE__FK_CORE_DEVICE_ELEMENT);
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table.
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, Keys.T_CORE_DEVICE__FK_CORE_DEVICE_ELEMENT, null);

        return _tCoreElementHierarchy;
    }

    @Override
    public TCoreDevice as(String alias) {
        return new TCoreDevice(DSL.name(alias), this);
    }

    @Override
    public TCoreDevice as(Name alias) {
        return new TCoreDevice(alias, this);
    }

    @Override
    public TCoreDevice as(Table<?> alias) {
        return new TCoreDevice(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreDevice rename(String name) {
        return new TCoreDevice(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreDevice rename(Name name) {
        return new TCoreDevice(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreDevice rename(Table<?> name) {
        return new TCoreDevice(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreDevice where(Condition condition) {
        return new TCoreDevice(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreDevice where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreDevice where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreDevice where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreDevice where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreDevice where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreDevice where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreDevice where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreDevice whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreDevice whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
